from PyQt5 import QtWidgets, uic, QtGui,QtCore
import sys, importlib
from libabr import core,app as apps,res, file
from libnam import files,control
import app, importlib, git

class MainApp(QtWidgets.QMainWindow):
    def btnCancel_act (self):
        apps.selectbox(None)
        apps.end ('beroz')
        self.Widget.close()


    def btnUpdate_act (self):
        self.pro.setEnabled (True)
        self.lblTop.setText ("Checking for updates ...")
        self.v = 1
        self.pro.setValue (self.v)

        QtCore.QTimer.singleShot(500,self.updateCheckRoot)

        self.btnUpdate.setEnabled (False)
        self.btnCancel.setEnabled (False)

    ## Steps ##
    def updateCheckRoot (self):
        self.v+=1
        self.pro.setValue (self.v)

        self.lblTop.setText ("Checking permissions ...")

        if self.Env.username=='guest':
            self.lblTop.setText("Fail to update, Permission denied")
            self.pro.setEnabled (False)
        elif self.Env.username=='root':
            QtCore.QTimer.singleShot(500, self.updateCheckMirror)
        else:
            sudoers = files.readall ('/etc/sudoers')
            if sudoers.__contains__(self.Env.username):
                QtCore.QTimer.singleShot(500, self.updateCheckMirror)
            else:
                self.lblTop.setText("Fail to update, Permission denied")
                self.pro.setEnabled(False)

    def updateCheckMirror(self):
        self.v += 1
        self.pro.setValue(self.v)

        self.lblTop.setText("Checking update mirror ...")

        self.upgrade_mirror = control.read_record('upgrade-mirror', '/etc/repo')

        ## Check nulls ##
        if self.upgrade_mirror == None or self.upgrade_mirror == '' or self.upgrade_mirror == " ":
            self.lblTop.setText("Fail to update, there is an error in mirror")
            self.pro.setEnabled (False)
        else:
            QtCore.QTimer.singleShot(500, self.updateGetBackups)

    def updateGetBackups (self):

        self.v += 1
        self.pro.setValue(self.v)

        self.lblTop.setText("Create backups for /etc ...")

        ## Back /etc files ##


        QtCore.QTimer.singleShot(500, self.bak1)

    def bak1 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/deskdirs', '/app/backups/deskdirs.bak')
        QtCore.QTimer.singleShot(500, self.bak2)

    def bak2 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/color', '/app/backups/color.bak')
        QtCore.QTimer.singleShot(500, self.bak3)

    def bak3 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/guest', '/app/backups/guest.bak')
        QtCore.QTimer.singleShot(500, self.bak4)

    def bak4 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/gui', '/app/backups/gui.bak')
        QtCore.QTimer.singleShot(500, self.bak5)

    def bak5 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/hostname', '/app/backups/hostname.bak')
        QtCore.QTimer.singleShot(500, self.bak6)

    def bak6 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/interface', '/app/backups/interface.bak')
        QtCore.QTimer.singleShot(500, self.bak7)

    def bak7 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/modules', '/app/backups/modules.bak')
        QtCore.QTimer.singleShot(500, self.bak8)

    def bak8 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/sudoers', '/app/backups/sudoers.bak')
        QtCore.QTimer.singleShot(500, self.bak9)

    def bak9 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/permtab', '/app/backups/permtab.bak')
        QtCore.QTimer.singleShot(500, self.bak10)

    def bak10 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/procmsg', '/app/backups/procmsg.bak')
        QtCore.QTimer.singleShot(500, self.bak11)

    def bak11 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/prompt', '/app/backups/prompt.bak')
        QtCore.QTimer.singleShot(500, self.bak12)

    def bak12 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/users/root', '/app/backups/root.bak')
        QtCore.QTimer.singleShot(500, self.bak13)

    def bak13 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/etc/time', '/app/backups/time.bak')
        QtCore.QTimer.singleShot(500, self.getPyabr)

    def getPyabr (self):
        self.lblTop.setText ('Getting the latest version of Pyabr ...')
        if files.isdir ('/tmp/pyabr'): files.removedirs ('/tmp/pyabr')
        git.Git(files.input("/tmp/")).clone(
            self.upgrade_mirror)  # Get the lates release of this clouding system ([/etc/repo]: upgrade-mirror)
        self.v+=10
        self.pro.setValue(self.v)
        QtCore.QTimer.singleShot(500, self.instPyabr)

    def instPyabr(self):
        self.lblTop.setText('Installing updates ...')
        core.system("saye /tmp/pyabr/upgrade.sa")
        self.v = 50
        self.pro.setValue(50)
        QtCore.QTimer.singleShot(500, self.unbak1)

    def unbak1 (self):
        self.lblTop.setText ('Unpacking backups of /etc ...')
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/app/backups/deskdirs.bak','/etc/deskdirs')
        QtCore.QTimer.singleShot(500, self.unbak2)


    def unbak2 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/app/backups/color.bak','/etc/color')
        QtCore.QTimer.singleShot(500, self.unbak3)

    def unbak3 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/guest.bak','/etc/guest')
        QtCore.QTimer.singleShot(500, self.unbak4)

    def unbak4 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/gui.bak','/etc/gui')
        QtCore.QTimer.singleShot(500, self.unbak5)

    def unbak5 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/app/backups/hostname.bak','/etc/hostname')
        QtCore.QTimer.singleShot(500, self.unbak6)

    def unbak6 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy('/app/backups/interface.bak','/etc/interface')
        QtCore.QTimer.singleShot(500, self.unbak7)

    def unbak7 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/modules.bak','/etc/modules')
        QtCore.QTimer.singleShot(500, self.unbak8)

    def unbak8 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/sudoers.bak','/etc/sudoers')
        QtCore.QTimer.singleShot(500, self.unbak9)

    def unbak9 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/permtab.bak','/etc/permtab')
        QtCore.QTimer.singleShot(500, self.unbak10)

    def unbak10 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/procmsg.bak','/etc/procmsg')
        QtCore.QTimer.singleShot(500, self.unbak11)

    def unbak11 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/prompt.bak','/etc/prompt')
        QtCore.QTimer.singleShot(500, self.unbak12)

    def unbak12 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/root.bak','/etc/users/root')
        QtCore.QTimer.singleShot(500, self.unbak13)

    def unbak13 (self):
        self.v += 1
        self.pro.setValue(self.v)
        files.copy( '/app/backups/time.bak','/etc/time')
        QtCore.QTimer.singleShot(500, self.Finish)

    def Finish (self):
        self.pro.setValue (100)
        self.lblTop.setText ("Finish updating, after updates you should restart the Pyabr")
        self.btnUpdate.setEnabled (True)
        self.btnUpdate.setText ("Restart")
        self.btnCancel.setEnabled (True)

        self.btnUpdate.clicked.connect (self.Restart)

    def Restart (self):
        core.reboot()
        exit(0)

    ## ##
    def __init__(self,args):
        super(MainApp, self).__init__()

        self.Backend = args[0]
        self.Env = args[1]
        self.Desktop = args[2]
        self.Widget = args[3]

        self.Widget.resize (600,127+40)

        self.Widget.setWindowTitle("Beroz Pyabr updater")

        ## Set Icon ##
        self.Widget.setWindowIcon (QtGui.QIcon(res.get('@logo/beroz')))

        uic.loadUi(res.get('@widget/beroz'),self)

        ## Pre update ##

        ## Finds ##

        self.btnUpdate = self.findChild(QtWidgets.QPushButton,'btnUpdate')
        self.btnCancel = self.findChild(QtWidgets.QPushButton, 'btnCancel')
        self.pro = self.findChild(QtWidgets.QProgressBar,'pro')
        self.lblTop = self.findChild(QtWidgets.QLabel,'lblTop')

        self.pro.setEnabled(False)

        self.btnCancel.clicked.connect (self.btnCancel_act)
        self.btnUpdate.clicked.connect (self.btnUpdate_act)

