import sys , os
from PyQt5 import QtWidgets, QtGui, QtCore
from PyQt5.QtGui import QBrush, QColor
from libabr import res
from libnam import files, control, modules

class MainApp (QtWidgets.QMainWindow):
    locale = control.read_record('locale','/etc/gui')
    def __init__(self,args):
        super().__init__()

        self.Backend = args[0]
        self.Env = args[1]
        self.Desktop = args[2]
        self.Widget = args[3]

        self.Widget.setWindowTitle (res.get('@string/app_name'))
        self.Widget.setWindowIcon (QtGui.QIcon(res.get('@logo/etcetra')))
        self.Widget.resize (1000,600)
        self.Widget.disableMaximizeButton()
        self.Widget.disableMinimizeButton()

        self.listView = QtWidgets.QListView()

        self.entry = QtGui.QStandardItemModel()
        self.listView.setModel(self.entry)
        self.listView.setIconSize(QtCore.QSize(64,64))
        self.listView.clicked[QtCore.QModelIndex].connect(self.on_clicked)
        self.layout().addWidget(self.listView)
        # When you receive the signal, you call QtGui.QStandardItemModel.itemFromIndex()
        # on the given model index to get a pointer to the item

        self.etclist = (files.list ('/usr/share/etcetra'))
        self.etclist.sort()

        self.listView.setGeometry(0, 0, int(self.Widget.width()/4), self.Widget.height())

        for formatname in self.etclist:
            it = QtGui.QStandardItem(formatname)
            it.setWhatsThis(formatname)

            ## Get etcetra name ##
            name = control.read_record ('name['+self.locale+"]",'/usr/share/etcetra/'+formatname)
            if name==None: name = formatname.replace('.etc','')

            ## Set etcetra name ##
            it.setText(name)

            ## Get etc logo ##
            logo = control.read_record ('icon','/usr/share/etcetra/'+formatname)
            if logo == None: logo = '@logo/etcetra'

            ## Set etc logo ##
            it.setIcon(QtGui.QIcon(res.get(logo)))

            self.entry.appendRow(it)

        self.itemOld = QtGui.QStandardItem("text")

    def on_clicked(self, index):
        self.item = self.entry.itemFromIndex(index)
        self.page = control.read_record('page','/usr/share/etcetra/'+self.item.whatsThis())

        if not self.page==None:
            page = modules.import_module(self.page).EtcetraPage([self.Backend,self.Env,self.Desktop,self.Widget])
            page.setGeometry (int(self.Widget.width()/4),0,int(self.Widget.width()-(self.Widget.width()/4)),self.Widget.height())
            self.layout().addWidget(page)