import sys , os
from PyQt5 import QtWidgets, QtGui, QtCore
from PyQt5.QtGui import QBrush, QColor
from libabr import res,core
from libnam import files, control
import fileview

class MainApp (QtWidgets.QMainWindow):
    def format (self,it,text):
        if os.path.isdir(self.dir + '/' + text):
            it.setIcon(QtGui.QIcon(res.get('@logo/folder')))
        else:
            format = it.whatsThis().split('.')
            format = max(format)
            if it.whatsThis().endswith(format):
                logo = control.read_record(format + '.logo', '/etc/ext')
                if not logo==None:
                    it.setIcon(QtGui.QIcon(res.get(logo)))
                else:
                    it.setIcon(QtGui.QIcon(res.get('@logo/gtk-file')))
            else:
                it.setIcon(QtGui.QIcon(res.get('@logo/gtk-file')))

    def __init__(self,args):
        super().__init__()

        self.Backend = args[0]
        self.Env = args[1]
        self.Desktop = args[2]
        self.Widget = args[3]

        self.x = fileview.FileListView()

        ## Menubar ##

        self.menubar = self.menuBar()
        self.file = self.menubar.addMenu("File")
        self.view = self.menubar.addMenu("View")
        self.help = self.menubar.addMenu("Help")

        ## File menu

        self.new_folder = self.file.addAction("New Folder")
        self.new_folder.triggered.connect(self.New_Folder)
        self.exit = self.file.addAction("Exit")
        self.exit.triggered.connect(self.Widget.close)

        ## end File menu

        ## end Menubar

        self.Widget.setWindowTitle (res.get('@string/app_name'))
        self.Widget.setWindowIcon (QtGui.QIcon(res.get('@logo/kesho')))
        self.Widget.resize (1000,600)

        self.setCentralWidget(self.x)

    def New_Folder (self):
        core.system ('inputbox "Enter a folder name:"')
        self.x.mkdir(files.readall("/proc/info/inp")) #  https://www.tutorialspoint.com/pyqt/pyqt_qinputdialog_widget.htm