
from PyQt5 import QtWidgets, QtGui, QtCore, uic
from libnam import control, files, permissions, modules, colors
from libabr import res, app as apps
import hashlib, app, sys,importlib
import os, shutil
import fileview

class OpenDialog (QtWidgets.QMainWindow):
    model = control.read_record ('model','/etc/gui')
    model = model.split ("x")
    mw = int(model[0])
    mh = int(model[1])
    locale = control.read_record("locale",'/etc/gui')
    def __init__(self):
        super(OpenDialog, self).__init__()

        uic.loadUi(res.get('@widget/open'),self)
        self.setStyleSheet('background-color: white;')
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        self.setGeometry(int(self.mw/2-self.width()/2),int(self.mh/2-self.height()/2),self.width(),self.height())

        ## Finds ##

        self.frm = self.findChild(QtWidgets.QFrame,'frm')
        self.btnOpen = self.findChild(QtWidgets.QPushButton, 'btnOpen')
        self.btnCancel = self.findChild(QtWidgets.QPushButton,'btnCancel')
        self.btnOpen.clicked.connect (self.inp)
        self.btnCancel.clicked.connect (self.cancel)
        self.lblInput = self.findChild(QtWidgets.QLabel,'lblInput')

        self.lblInput.setText(control.read_record('open.title[' + self.locale + "]", '/etc/configbox'))
        self.btnOpen.setText(control.read_record('open.open[' + self.locale + "]", '/etc/configbox'))
        self.btnCancel.setText(control.read_record('cancel[' + self.locale + "]", '/etc/configbox'))

        lay = QtWidgets.QVBoxLayout()
        self.frm.setLayout(lay)

        ## FileView enable ##
        #
        self.x = fileview.FileListView()
        lay.addWidget(self.x)

        self.show()

    def inp(self):
        if files.isfile ("/proc/info/fsel"):
            files.write ('/proc/info/inp',files.readall('/proc/info/fsel'))
            files.remove ("/proc/info/fsel")
        else:
            files.write ("/proc/info/inp",'')
        self.close()

    def cancel (self):
        files.write('/proc/info/inp', '')
        self.close()

appsv= QtWidgets.QApplication([])
w = OpenDialog()
appsv.exec_()