
from PyQt5 import QtWidgets, QtGui, QtCore, uic
from libnam import control, files, permissions, modules, colors
from libabr import res, app as apps
import hashlib, app, sys,importlib
import os, shutil
import fileview

class SaveDialog (QtWidgets.QMainWindow):
    model = control.read_record ('model','/etc/gui')
    model = model.split ("x")
    mw = int(model[0])
    mh = int(model[1])
    locale = control.read_record("locale",'/etc/gui')
    def __init__(self):
        super(SaveDialog, self).__init__()

        uic.loadUi(res.get('@widget/save'),self)
        self.setStyleSheet('background-color: white;')
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        self.setGeometry(int(self.mw/2-self.width()/2),int(self.mh/2-self.height()/2),self.width(),self.height())

        ## Finds ##

        self.frm = self.findChild(QtWidgets.QFrame,'frm')
        self.btnSave = self.findChild(QtWidgets.QPushButton, 'btnSave')
        self.btnCancel = self.findChild(QtWidgets.QPushButton,'btnCancel')
        self.btnSave.clicked.connect (self.inp)
        self.btnCancel.clicked.connect (self.cancel)
        self.lblInput = self.findChild(QtWidgets.QLabel,'lblInput')
        self.lblFileName = self.findChild(QtWidgets.QLabel,'lblFileName')
        self.leSave = self.findChild(QtWidgets.QLineEdit,'leSave')
        self.lblInput.setText(control.read_record('save.title[' + self.locale + "]", '/etc/configbox'))
        self.btnSave.setText(control.read_record('save.save[' + self.locale + "]", '/etc/configbox'))
        self.btnCancel.setText(control.read_record('cancel[' + self.locale + "]", '/etc/configbox'))
        self.lblFileName.setText(control.read_record('save.filename[' + self.locale + "]", '/etc/configbox'))

        lay = QtWidgets.QVBoxLayout()
        self.frm.setLayout(lay)

        ## FileView enable ##
        #
        self.x = fileview.FileListView()
        lay.addWidget(self.x)

        self.show()

    def inp(self):
        if not files.isdir (files.readall('/proc/info/dsel')+"/"+self.leSave.text()):
            files.write ('/proc/info/inp',files.readall('/proc/info/dsel')+"/"+self.leSave.text())
        self.close()

    def cancel (self):
        files.write('/proc/info/inp', '')
        self.close()

appsv= QtWidgets.QApplication([])
w = SaveDialog()
appsv.exec_()