from libnam import process, files, permissions, colors, control, modules
import os, importlib, getpass, sys
from libabr import core


lang = control.read_record('locale','/etc/gui')

## Graphical application library ##

## Start ID Process ##
def start (id):

    ## Check exists ##
    if files.isfile ('/proc/id/'+id):
        pass

    colors.show (id,'ok-start','')

    ## Create id ##
    files.create ("/proc/id/"+id)


    ## Check desktop shortcut ##
    if files.isfile ("/usr/share/applications/"+id):
        files.copy ("/usr/share/applications/"+id+".desk","/proc/id/"+id) # Copy all informations about this GUI application

    ## Set default id ##
    files.write ("/proc/info/id",id)


## Check id ##
def check(id):
    if not files.isfile ('/proc/id/'+id):
        return False
    else:
        return True

## End id ##
def end (id):

    if files.isfile ('/proc/id/'+id):
        ## Remove id ##
        colors.show(id,'ok-end','')
        files.remove ("/proc/id/"+id)

## Shut id ##
def shut ():
    default = files.readall("/proc/info/id")
    if files.isfile ("/proc/id/"+default):
        end(default)

## Endall id ##
def endall():
    files.remove('/proc/id/desktop')
    colors.show('desktop','ok-endid','')
    colors.show('kernel',"poweroff","")
    listid = files.list ("/proc/id")
    for i in listid:
        if files.isfile('/proc/id/'+i):
            files.remove('/proc/id/'+i)

## Switch id process ##
def switch (id):
    if files.isfile ('/proc/id/'+id):
        colors.show (id,'ok-id','')
        files.write ("/proc/info/id",id)

## Input Box ##

def inputbox (title):
    if not title==None:
        ## Get backup ##
        save = control.read_record('input.title[' + lang + "]", '/etc/configbox')

        ## Write control ##
        control.write_record('input.title[' + lang + "]", title, '/etc/configbox')

        core.system('inputbox')

        ## Save backup ##
        control.write_record('input.title[' + lang + "]", save, '/etc/configbox')
    else:
        core.system ('inputbox')


## Open Box ##

def openbox(title):
    ## Get backup ##
    if not title==None:
        save = control.read_record('open.title[' + lang + "]", '/etc/configbox')

        ## Write control ##
        control.write_record('open.title[' + lang + "]", title, '/etc/configbox')

        core.system('openbox')

        ## Save backup ##
        control.write_record('open.title[' + lang + "]", save, '/etc/configbox')
    else:
        core.system ('openbox')

## Save Box ##

def savebox(title):
    ## Get backup ##
    if not title==None:
        save = control.read_record('save.title[' + lang + "]", '/etc/configbox')

        ## Write control ##
        control.write_record('save.title[' + lang + "]", title, '/etc/configbox')

        core.system('savebox')

        ## Save backup ##
        control.write_record('save.title[' + lang + "]", save, '/etc/configbox')
    else:
        core.system ('savebox')

## Save Box ##

def selectbox(title):
    ## Get backup ##
    if not title==None:
        select = control.read_record('select.title[' + lang + "]", '/etc/configbox')

        ## Write control ##
        control.write_record('select.title[' + lang + "]", title, '/etc/configbox')

        core.system('selectbox')

        ## Save backup ##
        control.write_record('select.title[' + lang + "]", select, '/etc/configbox')
    else:
        core.system ('selectbox')