## Upgrade the clouding system ##

from libnam import control, files, colors, permissions
import git, wget,shutil
from libabr import core, archive

## Check root ##
if not permissions.check_root (files.readall("/proc/info/su")):
    colors.show ("upgrade","perm","")
    exit(0)

upgrade_mirror = control.read_record ('upgrade-mirror','/etc/repo')

## Check nulls ##
if upgrade_mirror==None or upgrade_mirror=='' or upgrade_mirror==" ":
    colors.show ("upgrade","fail","cannot upgrade system; upgrade mirror record is none.")
    exit()

    ## Back /etc files ##
colors.show("","ok","Create backup files ...")
files.copy ('/etc/deskdirs','/app/backups/deskdirs.bak')
files.copy('/etc/color', '/app/backups/color.bak')
files.copy('/etc/guest', '/app/backups/guest.bak')
files.copy('/etc/gui', '/app/backups/gui.bak')
files.copy('/etc/hostname', '/app/backups/hostname.bak')
files.copy('/etc/interface', '/app/backups/interface.bak')
files.copy('/etc/modules', '/app/backups/modules.bak')
files.copy('/etc/permtab', '/app/backups/permtab.bak')
files.copy('/etc/procmsg', '/app/backups/procmsg.bak')
files.copy('/etc/prompt', '/app/backups/prompt.bak')
files.copy('/etc/time', '/app/backups/time.bak')
files.copy('/etc/users/root', '/app/backups/root.bak')

    ## Get packages ##
colors.show("", "ok", "Get the lates version of Pyabr ...")
git.Git(files.input("/tmp/")).clone(
        upgrade_mirror)  # Get the lates release of this clouding system ([/etc/repo]: upgrade-mirror)

    ## Install Upgrades ##
colors.show("","ok","Install upgrade packages ...")
core.system("saye /tmp/pyabr/upgrade.sa")  # Run this script

    ## Unpack backups ##
colors.show("","ok","Unpack backup files ...")
files.cut ('/app/backups/deskdirs.bak','/etc/deskdirs')
files.cut ('/app/backups/color.bak','/etc/color')
files.cut ('/app/backups/guest.bak','/etc/guest')
files.cut ('/app/backups/gui.bak','/etc/gui')
files.cut ('/app/backups/hostname.bak','/etc/hostname')
files.cut ('/app/backups/interface.bak','/etc/interface')
files.cut ('/app/backups/modules.bak','/etc/modules')
files.cut ('/app/backups/permtab.bak','/etc/permtab')
files.cut ('/app/backups/procmsg.bak','/etc/procmsg')
files.cut ('/app/backups/prompt.bak','/etc/prompt')
files.cut ('/app/backups/time.bak','/etc/time')
files.cut ('/app/backups/root.bak','/etc/users/root')