import sys, os, hashlib, getpass
from libnam import files, control, permissions, colors

def uadd (input_username,user,password):
    if permissions.check_root(user):
        ## Check exists user ##
        if files.isfile("/etc/users/" + input_username) or input_username == "root":
            colors.show("uadd", "fail", input_username + ": user exists.")
        elif input_username == "guest":
            colors.show("uadd", "fail", "cannot create user account with guest username.")
        else:
            hashname = hashlib.sha3_256(str(input_username).encode()).hexdigest()
            hashcode = hashlib.sha3_512(str(password).encode()).hexdigest()

            files.create ("/etc/users/"+input_username)
            control.write_record ("username",hashname,'/etc/users/'+input_username)
            control.write_record ("code",hashcode,'/etc/users/'+input_username)

            permissions.create ("/desk/"+input_username,7,1,0,input_username) ## Create permission for another user
    else:
        colors.show ("uadd","perm","")

if not sys.argv == []:
    uadd(sys.argv[0],files.readall ("/proc/info/su"),sys.argv[1])
else:
    colors.show("uadd", "fail", "no inputs.")